CON                                

  _clkmode = xtal1 + pll16x   
  _xinfreq = 5_000_000

OBJ

  Pst : "parallax serial terminal"
  Adc : "jm_mcp342x"
  Format : "StrFmt"
  
PUB Main | timer, timeoutInterval, address0, address1
                                       
  Pst.Start (115_200)
  
  repeat
    result := Pst.rxcount
    Pst.Str(String(11, 13, "Press any key to start."))
    waitcnt(clkfreq / 10 + cnt)
  until result

  Pst.RxFlush

  Pst.Clear

  Pst.Home
  Pst.Str(String(11, 13, "Initializing ADC Driver"))      

  

  timeoutInterval := clkfreq * 2

  repeat address1 from 0 to 2
    repeat address0 from 0 to 2
      Pst.Str(string(11, 13, "Initializing driver with address =  "))
      Pst.Dec(address1)
      Pst.Str(string(", "))
      Pst.Dec(address0)
      Adc.Start(address1, address0)
      waitcnt(clkfreq + cnt) 
      Pst.Str(String(11, 13, "Set ADC Channel")) 
      Adc.Set_channel(0, Adc#SAMP_16, Adc#GAIN_1)
      timer := cnt
      repeat  
        result := Adc.Ready
      until result or cnt - timer > timeoutInterval

      if result
        Pst.Str(string(7, 11, 13, 11, 13, "       SUCCESS!", 11, 13, 7))
        Pst.Str(string(11, 13, "Device found address, A1 =  "))
        Pst.Dec(address1)
        Pst.Str(string(", A0 = "))
        Pst.Dec(address0)
        Pst.Str(string(11, 13, "Starting MainLoop Method"))
        waitcnt(clkfreq * 3 + cnt)
        Pst.Clear
        MainLoop
      else
        Pst.Str(string(11, 13, "Device not found using address  "))
        Pst.Dec(address1)
        Pst.Str(string(", "))
        Pst.Dec(address0)

  Pst.Str(string(7, 11, 13, "The sensor was not detected. There is an error either in the "))
  Pst.Str(string(11, 13, "way the sensor is wired or there is an error in the software. "))
  Pst.Str(string(7, 11, 13, "It's also possible the ADC chip is damaged. "))
  Pst.Str(string(11, 13, 11, 13, "End of Program", 7))
  repeat ' keeps cog alive so terminal window doesn't clear
  
PRI MainLoop | timer, timeoutInterval

  timeoutInterval := clkfreq * 2
      
  repeat
     Pst.Home
     Pst.Str(String(11, 13, "Set ADC Channel")) 
     Adc.Set_channel(0, Adc#SAMP_16, Adc#GAIN_1)
     
     Pst.Str(String(11, 13, "Waiting for Ready"))
     timer := cnt
     repeat  
       result := Adc.Ready
     until result or cnt - timer > timeoutInterval
     ifnot result
       Pst.Str(String(7, 13, 13, 13, 13, "Timeout! Check connections.", 7))
     result := Adc.Read_raw
     Pst.Str(string(11, 13, "Channel 1 raw =  "))
     Pst.Dec(result)
     Pst.Str(string(" = "))
     ReadableBin(result, 32)
     '' add readout of processed bits
     
     'waitcnt(clkfreq /20 + cnt)

PUB ReadableBin(localValue, size) | bufferPtr, localBuffer[12]    
'' This method display binary numbers
'' in easier to read groups of four
'' format.

  bufferPtr := Format.Ch(@localBuffer, "%")
  
  result := size // 4
   
  if result
    size -= result
    bufferPtr := Format.Bin(bufferPtr, localValue >> size, result)
    if size
      bufferPtr := Format.Ch(bufferPtr, "_")
  size -= 4
 
  repeat while size => 0
    bufferPtr := Format.Bin(bufferPtr, localValue >> size, 4)
    if size
      bufferPtr := Format.Ch(bufferPtr, "_")  
    size -= 4
    
  byte[bufferPtr] := 0  
  Pst.Str(@localBuffer)
